# -*- coding: utf-8 -*-
###########################################################################
# 
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
# eole@ac-dijon.fr 
#  
###########################################################################
"""
module de manipulation directe sur la base de mots-clefs
"""

import pickle

from filtrage.config import BAYES_DATABASE
from filtrage.errors import DataError

def load_pickle(filename=BAYES_DATABASE):
    """charge la base et renvoie un dictionnaire de dictionnaires"""
    fh = file(filename, 'r')
    bayesdict = pickle.load(fh)
    del(bayesdict['__Corpus__'])
    return bayesdict

def add_pickle(keyword, item, filename=BAYES_DATABASE):
    """charge la base et la modifie en ajoutant un mot-clef
    keyword : le mot-clef dans lequel une valeur est à ajouter
    item : (key, value) : le contenu à ajouter à la base
    """
    # ouverture du fichier
    fh = file(filename, 'r')
    bayesdict = pickle.load(fh)
    fh.close()
    if not bayesdict.has_key(keyword): #raise DataError, "le mot-clef doit exister"
        return False
    bayesdict[keyword][item[0]] = item[1]
    # sérialisation dans le fichier
    fh = file(filename, 'w')
    pickle.dump(bayesdict, fh)
    fh.close()
    return True

def del_pickle(keyword, delkey, filename=BAYES_DATABASE):
    """charge la base et la modifie en supprimant un mot-clef
    keyword : le mot-clef dans lequel une valeur est à ajouter
    delkey : le contenu à ajouter à la base
    """
    # ouverture du fichier
    fh = file(filename, 'r')
    bayesdict = pickle.load(fh)
    fh.close()
    if not bayesdict.has_key(keyword): #raise DataError, "le mot-clef doit exister"
        return False
    del(bayesdict[keyword][delkey])
    # sérialisation dans le fichier
    fh = file(filename, 'w')
    pickle.dump(bayesdict, fh)
    fh.close()
    return True

    
